diff -r bd39479d70b4 trytond/modules/stock_supply/purchase_request.py
--- a/trytond/modules/stock_supply/purchase_request.py	Thu Sep 20 16:16:56 2012 +0200
+++ b/trytond/modules/stock_supply/purchase_request.py	Mon Sep 24 20:36:43 2012 +0200
@@ -667,68 +625,61 @@
                     purchase_date = today
                 if purchase_date < today:
                     purchase_date = today
-                values = {
-                    'purchase_date': purchase_date,
-                    }
-                values.update(dict(key))
-                purchase_id = purchase_obj.create(values)
+                purchase = Purchase(purchase_date=purchase_date)
+                for f, v in key:
+                    setattr(purchase, f, v)
+                purchase.save()
                 for request in grouped_requests:
-                    values = self.compute_purchase_line(request)
-                    values['purchase'] = purchase_id
-                    line_id = line_obj.create(values)
-                    request_obj.write(request.id, {
-                            'purchase_line': line_id,
+                    line = self.compute_purchase_line(request)
+                    line.purchase = purchase
+                    line.save()
+                    Request.write([request], {
+                            'purchase_line': line.id,
                             })
         return 'end'
 
-    def _get_tax_rule_pattern(self, request):
+    @staticmethod
+    def _get_tax_rule_pattern(request):
         '''
         Get tax rule pattern
+        '''
+        return {}
 
-        :param request: the BrowseRecord of the purchase request
-        :return: a dictionary to use as pattern for tax rule
-        '''
-        res = {}
-        return res
+    @classmethod
+    def compute_purchase_line(cls, request):
+        pool = Pool()
+        Product = pool.get('product.product')
+        Line = pool.get('purchase.line')
 
-    def compute_purchase_line(self, request):
-        pool = Pool()
-        product_obj = pool.get('product.product')
-        tax_rule_obj = pool.get('account.tax.rule')
-        line_obj = pool.get('purchase.line')
-
-        line = {
-            'product': request.product.id,
-            'unit': request.uom.id,
-            'quantity': request.quantity,
-            'description': request.product.name,
-            }
+        line = Line(
+            product=request.product,
+            unit=request.uom,
+            quantity=request.quantity,
+            description=request.product.name,
+            )
 
         # XXX purchase with several lines of the same product
         with Transaction().set_context(uom=request.uom.id,
                 supplier=request.party.id,
                 currency=request.company.currency.id):
-            product_price = product_obj.get_purchase_price(
-                    [request.product.id], request.quantity)[request.product.id]
+            product_price = Product.get_purchase_price(
+                [request.product], request.quantity)[request.product.id]
             product_price = product_price.quantize(
-                Decimal(1) / 10 ** line_obj.unit_price.digits[1])
+                Decimal(1) / 10 ** Line.unit_price.digits[1])
 
         if product_price is None:
-            self.raise_user_error('missing_price', (request.product.name,
+            cls.raise_user_error('missing_price', (request.product.name,
                     request.product.id), 'please_update')
-        line['unit_price'] = product_price
+        line.unit_price = product_price
 
         taxes = []
         for tax in request.product.supplier_taxes_used:
             if request.party and request.party.supplier_tax_rule:
-                pattern = self._get_tax_rule_pattern(request)
-                tax_ids = tax_rule_obj.apply(request.party.supplier_tax_rule,
-                        tax, pattern)
+                pattern = cls._get_tax_rule_pattern(request)
+                tax_ids = request.party.supplier_tax_rule.apply(tax, pattern)
                 if tax_ids:
                     taxes.extend(tax_ids)
                 continue
             taxes.append(tax.id)
-        line['taxes'] = [('add', taxes)]
+        line.taxes = taxes
         return line
-
-CreatePurchase()
diff -r bd39479d70b4 trytond/modules/stock_supply/shipment.py
--- a/trytond/modules/stock_supply/shipment.py	Thu Sep 20 16:16:56 2012 +0200
+++ b/trytond/modules/stock_supply/shipment.py	Mon Sep 24 20:36:43 2012 +0200
@@ -2,13 +2,17 @@
 #this repository contains the full copyright notices and license terms.
 from trytond.model import ModelView, ModelSQL
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
+
+__all__ = ['ShipmentInternal']
+__metaclass__ = PoolMeta
 
 
 class ShipmentInternal(ModelSQL, ModelView):
-    _name = 'stock.shipment.internal'
+    __name__ = 'stock.shipment.internal'
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.2: packing renamed into shipment
         cursor.execute("UPDATE ir_model_data "\
@@ -19,26 +23,27 @@
                 "SET model = REPLACE(model, 'packing', 'shipment') "\
                 "WHERE model like '%%packing%%' AND module = %s",
                 (module_name,))
-        super(ShipmentInternal, self).init(module_name)
+        super(ShipmentInternal, cls).__register__(module_name)
 
-    def generate_internal_shipment(self):
+    @classmethod
+    def generate_internal_shipment(cls):
         """
         Generate internal shipments to meet order points defined on
         non-warehouse location.
         """
         pool = Pool()
-        order_point_obj = pool.get('stock.order_point')
-        uom_obj = pool.get('product.uom')
-        product_obj = pool.get('product.product')
-        date_obj = pool.get('ir.date')
-        user_obj = pool.get('res.user')
-        user_record = user_obj.browse(Transaction().user)
-        today = date_obj.today()
+        OrderPoint = pool.get('stock.order_point')
+        Uom = pool.get('product.uom')
+        Product = pool.get('product.product')
+        Date = pool.get('ir.date')
+        User = pool.get('res.user')
+        Move = pool.get('stock.move')
+        user_record = User(Transaction().user)
+        today = Date.today()
         # fetch quantities on order points
-        op_ids = order_point_obj.search([
+        order_points = OrderPoint.search([
             ('type', '=', 'internal'),
             ])
-        order_points = order_point_obj.browse(op_ids)
         id2product = {}
         location_ids = []
         for op in order_points:
@@ -46,7 +51,7 @@
             location_ids.append(op.storage_location.id)
 
         with Transaction().set_context(stock_date_end=today):
-            pbl = product_obj.products_by_location(location_ids,
+            pbl = Product.products_by_location(location_ids,
                 list(id2product.iterkeys()), with_childs=True)
 
         # Create a list of move to create
@@ -60,21 +65,21 @@
                 moves[key] = op.max_quantity - qty
 
         # Compare with existing draft shipments
-        shipment_ids = self.search([
+        shipments = cls.search([
                 ('state', '=', 'draft'),
                 ['OR',
                     ('planned_date', '<=', today),
                     ('planned_date', '=', None),
                     ],
                 ])
-        for shipment in self.browse(shipment_ids):
+        for shipment in shipments:
             for move in shipment.moves:
                 key = (shipment.to_location.id,
                        shipment.from_location.id,
                        move.product.id)
                 if key not in moves:
                     continue
-                quantity = uom_obj.compute_qty(move.uom, move.quantity,
+                quantity = Uom.compute_qty(move.uom, move.quantity,
                     id2product[move.product.id].default_uom)
                 moves[key] = max(0, moves[key] - quantity)
 
@@ -85,27 +90,22 @@
             shipments.setdefault(
                 (from_location, to_location), []).append((product, qty))
         # Create shipments and moves
-        for shipment, moves in shipments.iteritems():
-            from_location, to_location = shipment
-            values = {
-                'from_location': from_location,
-                'to_location': to_location,
-                'planned_date': today,
-                'moves': [],
-                }
+        for locations, moves in shipments.iteritems():
+            from_location, to_location = locations
+            shipment = cls(
+                from_location=from_location,
+                to_location=to_location,
+                planned_date=today,
+                moves=[],
+                )
             for move in moves:
                 product, qty = move
-                values['moves'].append(
-                    ('create',
-                        {
-                            'from_location': from_location,
-                            'to_location': to_location,
-                            'product': product,
-                            'quantity': qty,
-                            'uom': id2product[product].default_uom.id,
-                            'company': user_record.company.id,
-                            }
+                shipment.moves.append(Move(
+                        from_location=from_location,
+                        to_location=to_location,
+                        product=product,
+                        quantity=qty,
+                        uom=id2product[product].default_uom,
+                        company=user_record.company,
                         ))
-            self.create(values)
-
-ShipmentInternal()
+            shipment.save()
diff -r bd39479d70b4 trytond/modules/stock_supply/tests/test_stock_supply.py
--- a/trytond/modules/stock_supply/tests/test_stock_supply.py	Thu Sep 20 16:16:56 2012 +0200
+++ b/trytond/modules/stock_supply/tests/test_stock_supply.py	Mon Sep 24 20:36:43 2012 +0200
@@ -64,10 +64,7 @@
         '''
         for purchase_date, delivery_time, supply_date in DATES:
             with Transaction().start(DB_NAME, USER, context=CONTEXT):
-                product_supplier_id = self.create_product_supplier(
-                    delivery_time)
-                product_supplier = self.product_supplier.browse(
-                    product_supplier_id)
+                product_supplier = self.create_product_supplier(delivery_time)
                 date = self.product_supplier.compute_supply_date(
                     product_supplier, purchase_date)
                 self.assertEqual(date, supply_date)
@@ -78,10 +75,7 @@
         '''
         for purchase_date, delivery_time, supply_date in DATES:
             with Transaction().start(DB_NAME, USER, context=CONTEXT):
-                product_supplier_id = self.create_product_supplier(
-                    delivery_time)
-                product_supplier = self.product_supplier.browse(
-                    product_supplier_id)
+                product_supplier = self.create_product_supplier(delivery_time)
                 date = self.product_supplier.compute_purchase_date(
                     product_supplier, supply_date)
                 self.assertEqual(date, purchase_date)
@@ -93,48 +87,48 @@
         :param delivery_time: time in days needed to supply
         :return: the id of the Product Supplier
         '''
-        uom_category_id = self.uom_category.create({'name': 'Test'})
-        uom_id = self.uom.create({
+        uom_category = self.uom_category.create({'name': 'Test'})
+        uom = self.uom.create({
             'name': 'Test',
             'symbol': 'T',
-            'category': uom_category_id,
+            'category': uom_category.id,
             'rate': 1.0,
             'factor': 1.0,
             })
-        category_id = self.category.create({'name': 'ProdCategoryTest'})
-        product_id = self.product.create({
+        category = self.category.create({'name': 'ProdCategoryTest'})
+        product = self.product.create({
                 'name': 'ProductTest',
-                'default_uom': uom_id,
-                'category': category_id,
+                'default_uom': uom.id,
+                'category': category.id,
                 'account_category': True,
                 'list_price': Decimal(0),
                 'cost_price': Decimal(0),
                 })
-        company_id, = self.company.search([('name', '=', 'B2CK')])
-        self.user.write(USER, {
-            'main_company': company_id,
-            'company': company_id,
+        company, = self.company.search([('name', '=', 'B2CK')])
+        self.user.write([self.user(USER)], {
+            'main_company': company.id,
+            'company': company.id,
             })
-        receivable_id, = self.account.search([
+        receivable, = self.account.search([
             ('kind', '=', 'receivable'),
-            ('company', '=', company_id),
+            ('company', '=', company.id),
             ])
-        payable_id, = self.account.search([
+        payable, = self.account.search([
             ('kind', '=', 'payable'),
-            ('company', '=', company_id),
+            ('company', '=', company.id),
             ])
-        supplier_id = self.party.create({
+        supplier = self.party.create({
             'name': 'supplier',
-            'account_receivable': receivable_id,
-            'account_payable': payable_id,
+            'account_receivable': receivable.id,
+            'account_payable': payable.id,
             })
-        product_supplier_id = self.product_supplier.create({
-            'product': product_id,
-            'company': company_id,
-            'party': supplier_id,
+        product_supplier = self.product_supplier.create({
+            'product': product.id,
+            'company': company.id,
+            'party': supplier.id,
             'delivery_time': delivery_time,
             })
-        return product_supplier_id
+        return product_supplier
 
 
 def suite():
diff -r a844b23b6c90 trytond/modules/stock_supply_day/__init__.py
--- a/trytond/modules/stock_supply_day/__init__.py	Thu Sep 20 16:18:14 2012 +0200
+++ b/trytond/modules/stock_supply_day/__init__.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,4 +1,12 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .purchase import *
+
+
+def register():
+    Pool.register(
+        ProductSupplier,
+        ProductSupplierDay,
+        module='stock_supply_day', type_='model')
diff -r a844b23b6c90 trytond/modules/stock_supply_day/purchase.py
--- a/trytond/modules/stock_supply_day/purchase.py	Thu Sep 20 16:18:14 2012 +0200
+++ b/trytond/modules/stock_supply_day/purchase.py	Mon Sep 24 20:36:43 2012 +0200
@@ -2,18 +2,21 @@
 #this repository contains the full copyright notices and license terms.
 import datetime
 from trytond.model import ModelView, ModelSQL, fields
+from trytond.pool import PoolMeta
 
+__all__ = ['ProductSupplier', 'ProductSupplierDay']
+__metaclass__ = PoolMeta
 
-class ProductSupplier(ModelSQL, ModelView):
-    _name = 'purchase.product_supplier'
+
+class ProductSupplier:
+    __name__ = 'purchase.product_supplier'
     weekdays = fields.One2Many('purchase.product_supplier.day',
         'product_supplier', 'Week Days')
 
-    def compute_supply_date(self, product_supplier, date=None):
-        date = super(ProductSupplier, self).compute_supply_date(
-                product_supplier, date=date)
+    def compute_supply_date(self, date=None):
+        date = super(ProductSupplier, self).compute_supply_date(date=date)
         earlier_date = None
-        for day in product_supplier.weekdays:
+        for day in self.weekdays:
             weekday = int(day.weekday)
             diff = weekday - date.weekday()
             if diff < 0:
@@ -25,9 +28,9 @@
             earlier_date = new_date
         return earlier_date
 
-    def compute_purchase_date(self, product_supplier, date):
+    def compute_purchase_date(self, date):
         later_date = None
-        for day in product_supplier.weekdays:
+        for day in self.weekdays:
             weekday = int(day.weekday)
             diff = (date.weekday() - weekday) % 7
             new_date = date - datetime.timedelta(diff)
@@ -36,18 +39,13 @@
             later_date = new_date
         if later_date:
             date = later_date
-        return super(ProductSupplier, self).compute_purchase_date(
-                product_supplier, date)
-
-ProductSupplier()
+        return super(ProductSupplier, self).compute_purchase_date(date)
 
 
 class ProductSupplierDay(ModelSQL, ModelView):
     'Product Supplier Day'
-    _name = 'purchase.product_supplier.day'
+    __name__ = 'purchase.product_supplier.day'
     _rec_name = 'weekday'
-    _description = __doc__
-
     product_supplier = fields.Many2One('purchase.product_supplier', 'Supplier',
             required=True, ondelete='CASCADE')
     weekday = fields.Selection([
@@ -60,11 +58,11 @@
         ('6', 'Sunday'),
         ], 'Week Day', required=True, sort=False)
 
-    def __init__(self):
-        super(ProductSupplierDay, self).__init__()
-        self._order.insert(0, ('weekday', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(ProductSupplierDay, cls).__setup__()
+        cls._order.insert(0, ('weekday', 'ASC'))
 
-    def default_weekday(self):
+    @staticmethod
+    def default_weekday():
         return '0'
-
-ProductSupplierDay()
diff -r a844b23b6c90 trytond/modules/stock_supply_day/tests/test_stock_supply_day.py
--- a/trytond/modules/stock_supply_day/tests/test_stock_supply_day.py	Thu Sep 20 16:18:14 2012 +0200
+++ b/trytond/modules/stock_supply_day/tests/test_stock_supply_day.py	Mon Sep 24 20:36:43 2012 +0200
@@ -69,12 +69,9 @@
             # Monday, the 2011-12-05.
         for purchase_date, delivery_time, weekday, supply_date in dates:
             with Transaction().start(DB_NAME, USER, context=CONTEXT):
-                product_supplier_id = self.create_product_supplier_day(
+                product_supplier = self.create_product_supplier_day(
                     delivery_time, weekday)
-                product_supplier = self.product_supplier.browse(
-                    product_supplier_id)
-                date = self.product_supplier.compute_supply_date(
-                    product_supplier, purchase_date)
+                date = product_supplier.compute_supply_date(purchase_date)
                 self.assertEqual(date, supply_date)
 
     def test0020compute_purchase_date(self):
@@ -97,12 +94,9 @@
             # the forecast purchase date is the 2011-12-27.
         for purchase_date, delivery_time, weekday, supply_date in dates:
             with Transaction().start(DB_NAME, USER, context=CONTEXT):
-                product_supplier_id = self.create_product_supplier_day(
+                product_supplier = self.create_product_supplier_day(
                     delivery_time, weekday)
-                product_supplier = self.product_supplier.browse(
-                    product_supplier_id)
-                date = self.product_supplier.compute_purchase_date(
-                    product_supplier, supply_date)
+                date = product_supplier.compute_purchase_date(supply_date)
                 self.assertEqual(date, purchase_date)
 
     def create_product_supplier_day(self, delivery_time, weekday):
@@ -113,52 +107,52 @@
         :param weekday: supply day of the week (0 - 6)
         :return: the id of the Product Supplier Day
         '''
-        uom_category_id = self.uom_category.create({'name': 'Test'})
-        uom_id = self.uom.create({
+        uom_category = self.uom_category.create({'name': 'Test'})
+        uom = self.uom.create({
             'name': 'Test',
             'symbol': 'T',
-            'category': uom_category_id,
+            'category': uom_category.id,
             'rate': 1.0,
             'factor': 1.0,
             })
-        category_id = self.category.create({'name': 'ProdCategoryTest'})
-        product_id = self.product.create({
+        category = self.category.create({'name': 'ProdCategoryTest'})
+        product = self.product.create({
                 'name': 'ProductTest',
-                'default_uom': uom_id,
-                'category': category_id,
+                'default_uom': uom.id,
+                'category': category.id,
                 'account_category': True,
                 'list_price': Decimal(0),
                 'cost_price': Decimal(0),
                 })
-        company_id, = self.company.search([('name', '=', 'B2CK')])
-        self.user.write(USER, {
-            'main_company': company_id,
-            'company': company_id,
+        company, = self.company.search([('name', '=', 'B2CK')])
+        self.user.write([self.user(USER)], {
+            'main_company': company.id,
+            'company': company.id,
             })
-        receivable_id, = self.account.search([
+        receivable, = self.account.search([
             ('kind', '=', 'receivable'),
-            ('company', '=', company_id),
+            ('company', '=', company.id),
             ])
-        payable_id, = self.account.search([
+        payable, = self.account.search([
             ('kind', '=', 'payable'),
-            ('company', '=', company_id),
+            ('company', '=', company.id),
             ])
-        supplier_id = self.party.create({
+        supplier = self.party.create({
             'name': 'supplier',
-            'account_receivable': receivable_id,
-            'account_payable': payable_id,
+            'account_receivable': receivable.id,
+            'account_payable': payable.id,
             })
-        product_supplier_id = self.product_supplier.create({
-            'product': product_id,
-            'company': company_id,
-            'party': supplier_id,
+        product_supplier = self.product_supplier.create({
+            'product': product.id,
+            'company': company.id,
+            'party': supplier.id,
             'delivery_time': delivery_time,
             })
         self.product_supplier_day.create({
-            'product_supplier': product_supplier_id,
+            'product_supplier': product_supplier.id,
             'weekday': str(weekday),
             })
-        return product_supplier_id
+        return product_supplier
 
 
 def suite():
diff -r d163ac00ea95 trytond/modules/stock_supply_forecast/__init__.py
--- a/trytond/modules/stock_supply_forecast/__init__.py	Fri Jun 08 19:34:35 2012 +0200
+++ b/trytond/modules/stock_supply_forecast/__init__.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,4 +1,11 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of this
 #repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .purchase_request import *
+
+
+def register():
+    Pool.register(
+        PurchaseRequest,
+        module='stock_supply_forecast', type_='model')
diff -r d163ac00ea95 trytond/modules/stock_supply_forecast/purchase_request.py
--- a/trytond/modules/stock_supply_forecast/purchase_request.py	Fri Jun 08 19:34:35 2012 +0200
+++ b/trytond/modules/stock_supply_forecast/purchase_request.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,24 +1,26 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import Model
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['PurchaseRequest']
+__metaclass__ = PoolMeta
 
-class PurchaseRequest(Model):
-    _name = 'purchase.request'
 
-    def generate_requests(self):
-        forecast_obj = Pool().get('stock.forecast')
-        date_obj = Pool().get('ir.date')
+class PurchaseRequest:
+    __name__ = 'purchase.request'
 
-        today = date_obj.today()
+    @classmethod
+    def generate_requests(cls):
+        pool = Pool()
+        Forecast = pool.get('stock.forecast')
+        Date = pool.get('ir.date')
 
-        forecast_ids = forecast_obj.search([
+        today = Date.today()
+
+        forecasts = Forecast.search([
                 ('to_date', '>=', today),
                 ('state', '=', 'done'),
                 ])
-        forecast_obj.create_moves(forecast_ids)
-        super(PurchaseRequest, self).generate_requests()
-        forecast_obj.delete_moves(forecast_ids)
-
-PurchaseRequest()
+        Forecast.create_moves(forecasts)
+        super(PurchaseRequest, cls).generate_requests()
+        Forecast.delete_moves(forecasts)
diff -r 3ac6556ec8e0 trytond/modules/stock_supply_production/__init__.py
--- a/trytond/modules/stock_supply_production/__init__.py	Mon Sep 24 18:27:07 2012 +0200
+++ b/trytond/modules/stock_supply_production/__init__.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,6 +1,20 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from stock import *
 from production import *
 from product import *
+
+
+def register():
+    Pool.register(
+        OrderPoint,
+        Configuration,
+        Production,
+        CreateProductionRequestStart,
+        Product,
+        module='stock_supply_production', type_='model')
+    Pool.register(
+        CreateProductionRequest,
+        module='stock_supply_production', type_='wizard')
diff -r 3ac6556ec8e0 trytond/modules/stock_supply_production/product.py
--- a/trytond/modules/stock_supply_production/product.py	Mon Sep 24 18:27:07 2012 +0200
+++ b/trytond/modules/stock_supply_production/product.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,17 +1,17 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
-from trytond.model import Model
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['Product']
+__metaclass__ = PoolMeta
 
-class Product(Model):
-    _name = 'product.product'
 
-    def get_supply_period(self, product):
+class Product:
+    __name__ = 'product.product'
+
+    def get_supply_period(self):
         'Return the supply period for the product'
         pool = Pool()
-        configuration_obj = pool.get('production.configuration')
-        return int(configuration_obj.browse(1).supply_period or 0)
-
-Product()
+        Configuration = pool.get('production.configuration')
+        return int(Configuration(1).supply_period or 0)
